var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.js
var src_exports = {};
__export(src_exports, {
  alterState: () => import_language_common2.alterState,
  arrayToString: () => import_language_common2.arrayToString,
  as: () => import_language_common2.as,
  combine: () => import_language_common2.combine,
  cursor: () => import_language_common2.cursor,
  dataPath: () => import_language_common2.dataPath,
  dataValue: () => import_language_common2.dataValue,
  dateFns: () => import_language_common2.dateFns,
  default: () => src_default,
  each: () => import_language_common2.each,
  execute: () => execute,
  field: () => import_language_common2.field,
  fields: () => import_language_common2.fields,
  fn: () => import_language_common2.fn,
  fnIf: () => import_language_common2.fnIf,
  insert: () => insert,
  lastReferenceValue: () => import_language_common2.lastReferenceValue,
  merge: () => import_language_common2.merge,
  sourceValue: () => import_language_common2.sourceValue,
  sql: () => sql,
  upsert: () => upsert,
  upsertMany: () => upsertMany
});
module.exports = __toCommonJS(src_exports);

// src/Adaptor.js
var Adaptor_exports = {};
__export(Adaptor_exports, {
  alterState: () => import_language_common2.alterState,
  arrayToString: () => import_language_common2.arrayToString,
  as: () => import_language_common2.as,
  combine: () => import_language_common2.combine,
  cursor: () => import_language_common2.cursor,
  dataPath: () => import_language_common2.dataPath,
  dataValue: () => import_language_common2.dataValue,
  dateFns: () => import_language_common2.dateFns,
  each: () => import_language_common2.each,
  execute: () => execute,
  field: () => import_language_common2.field,
  fields: () => import_language_common2.fields,
  fn: () => import_language_common2.fn,
  fnIf: () => import_language_common2.fnIf,
  insert: () => insert,
  lastReferenceValue: () => import_language_common2.lastReferenceValue,
  merge: () => import_language_common2.merge,
  sourceValue: () => import_language_common2.sourceValue,
  sql: () => sql,
  upsert: () => upsert,
  upsertMany: () => upsertMany
});
var import_language_common = require("@openfn/language-common");
var import_util = require("@openfn/language-common/util");
var import_mysql = __toESM(require("mysql"), 1);
var import_squel = __toESM(require("squel"), 1);
var import_language_common2 = require("@openfn/language-common");
function sql(sqlQuery, options = {}) {
  return (state) => {
    const { connection } = state;
    const [resolvedSqlQuery, resolvedOptions] = (0, import_util.expandReferences)(
      state,
      sqlQuery,
      options
    );
    const { writeSql = false, execute: execute2 = true } = resolvedOptions;
    if (writeSql) {
      console.log("Prepared SQL:", resolvedSqlQuery);
    }
    if (!execute2) {
      return {
        ...state,
        queries: [...state.queries || [], resolvedSqlQuery]
      };
    }
    return new Promise((resolve, reject) => {
      connection.query(resolvedSqlQuery, (err, results, fields2) => {
        if (err) {
          console.log("Error executing query. Disconnecting from database.");
          connection.end();
          return reject(err);
        }
        resolve({ ...state, response: { body: results, fields: fields2 } });
      });
    });
  };
}
function execute(...operations) {
  const initialState = {
    references: [],
    data: null
  };
  return (state) => {
    return (0, import_language_common.execute)(
      connect,
      ...operations,
      disconnect,
      cleanupState
    )({ ...initialState, ...state });
  };
}
function connect(state) {
  const { host, port, database, password, user } = state.configuration;
  var connection = import_mysql.default.createConnection({
    host,
    user,
    password,
    database,
    port
  });
  connection.connect();
  console.log(`Preparing to query "` + database + `"...`);
  return { ...state, connection };
}
function disconnect(state) {
  state.connection.end();
  return state;
}
function cleanupState(state) {
  delete state.connection;
  return state;
}
function insert(table, fields2) {
  return (state) => {
    let { connection } = state;
    const [valuesObj] = (0, import_util.expandReferences)(state, fields2);
    const squelMysql = import_squel.default.useFlavour("mysql");
    var sqlParams = squelMysql.insert({
      autoQuoteFieldNames: true
    }).into(table).setFields(valuesObj).toParam();
    const sql2 = sqlParams.text;
    const inserts = sqlParams.values;
    const sqlString = import_mysql.default.format(sql2, inserts);
    console.log(`Executing MySQL query: ${sqlString}`);
    return new Promise((resolve, reject) => {
      connection.query(sqlString, function(err, results, fields3) {
        if (err) {
          reject(err);
          console.log("There is an error. Disconnecting from database.");
          connection.end();
        } else {
          console.log("Success...");
          console.log(results);
          console.log(fields3);
          resolve(results);
        }
      });
    }).then((data) => {
      const nextState = { ...state, response: { body: data } };
      return nextState;
    });
  };
}
function upsert(table, fields2) {
  return (state) => {
    let { connection } = state;
    const [valuesObj] = (0, import_util.expandReferences)(state, fields2);
    const squelMysql = import_squel.default.useFlavour("mysql");
    var insertParams = squelMysql.insert({
      autoQuoteFieldNames: true
    }).into(table).setFields(valuesObj).toParam();
    var sql2 = insertParams.text;
    var inserts = insertParams.values;
    const insertString = import_mysql.default.format(sql2, inserts);
    var updateParams = squelMysql.update({
      autoQuoteFieldNames: true
    }).table("").setFields(valuesObj).toParam();
    var sql2 = updateParams.text;
    var inserts = updateParams.values;
    const updateString = import_mysql.default.format(sql2, inserts);
    const upsertString = insertString + ` ON DUPLICATE KEY UPDATE ` + updateString.slice(10);
    console.log("Executing MySQL query: " + upsertString);
    return new Promise((resolve, reject) => {
      connection.query(upsertString, function(err, results, fields3) {
        if (err) {
          reject(err);
          console.log("That's an error. Disconnecting from database.");
          connection.end();
        } else {
          console.log("Success...");
          console.log(results);
          console.log(fields3);
          resolve(results);
        }
      });
    }).then((data) => {
      const nextState = { ...state, response: { body: data } };
      return nextState;
    });
  };
}
function upsertMany(table, data) {
  return function(state) {
    return new Promise(function(resolve, reject) {
      const [rows] = (0, import_util.expandReferences)(state, data);
      if (!rows || rows.length === 0) {
        console.log("No records provided; skipping upsert.");
        resolve(state);
      }
      const squelMysql = import_squel.default.useFlavour("mysql");
      const columns = Object.keys(rows[0]);
      let upsertSql = squelMysql.insert().into(table).setFieldsRows(rows);
      columns.map((c) => {
        upsertSql = upsertSql.onDupUpdate(`${c}=values(${c})`);
      });
      const upsertString = upsertSql.toString();
      let { connection } = state;
      connection.query(upsertString, function(err, results, fields2) {
        if (err) {
          reject(err);
          console.log("That's an error. Disconnecting from database.");
          connection.end();
        } else {
          console.log("Success...");
          console.log(results);
          console.log(fields2);
          resolve(results);
        }
      });
    }).then(function(data2) {
      const nextState = { ...state, response: { body: data2 } };
      return nextState;
    });
  };
}

// src/index.js
var src_default = Adaptor_exports;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  alterState,
  arrayToString,
  as,
  combine,
  cursor,
  dataPath,
  dataValue,
  dateFns,
  each,
  execute,
  field,
  fields,
  fn,
  fnIf,
  insert,
  lastReferenceValue,
  merge,
  sourceValue,
  sql,
  upsert,
  upsertMany
});
